

/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com
09.07.2017
PrintInterface.h
*/

#ifndef PRINTER_INTERFACE_H
	#define PRINTER_INTERFACE_H



#define LED_BRAILLE_DDRX		DDRD
#define LED_BRAILLE_PORT		PORTD
#define LED_BRAILLE_BITS		0xFC  // REALE HARDWAREBIST
#define LED_BRAILLE_LEDCNT		6
#define LED_BRAILLE_BIST_OFFSET	2
#define INIT_BRAILLE_LED()	(LED_BRAILLE_DDRX |= LED_BRAILLE_BITS )
#define CLR_BRAILLE_LED()	(LED_BRAILLE_PORT &= ~LED_BRAILLE_BITS)
#define SET_BRAILLE_LED(X)	(LED_BRAILLE_PORT |= ((X) << LED_BRAILLE_BIST_OFFSET) )
#define ANIMATION_DELAY_MS	100


#define BRAILLE_STRICH_LINKS	0x07
#define BRAILLE_STRICH_RECHTS   0x38
#define BRAILLE_GERADE_OBEN		0x09
#define BRAILLE_GERADE_MITTE	0x12
#define BRAILLE_GERADE_UNTEN	0x24

#define BRL_PRINTER_LINEPOS_MAX	16
#define BRL_PRINTER_LINES_MAX	20
#define PAPIERVORSCHUB_ZEIT 500
#define WAGEN_RUECKLAUF_ZEIT 600

/*
#define PRINTER_RTS			0x01
#define PRINTER_CTS			0x02
#define PRINTER_ACTION		0x04

*/

// ====================================================
#define Printer_STOP		0x01
#define PAPERLINES_FULL		0x02
#define PAPIERVORSCHUB		0x04
#define WAGENRUECKLAUF		0x10
#define PRINTER_BUSY		0x80
//gu8PrinterStatus_Flags
extern uint8_t gu8PrinterStatus_Flags;
// ====================================================

#define NEW_LINE_EVENT		0x01
extern uint8_t gu8Printer_Event_Flags;
// ====================================================

//Globals
extern uint8_t gu8WriteHeadPos;
extern uint8_t gu8LineCnt;
extern uint8_t gu8ActualPrinterBrailleChar;

//Proto
void BRL_PrintChar(uint8_t u8Char);
extern void BRL_Print_One(uint8_t u8Pars);
extern void Aktion_Pos_PapierAnfang(void);
extern void Aktion_PapierVorschub( void );
extern void Aktion_PaperChanged(void);
extern uint8_t Check_PrintLines_Available(void );

extern void GOWritehead_Pos(uint8_t u8Pos );
extern void Trigger_BRL_Printer(void);
#endif 