#define SOFTWARE	"RxRingBuf.c"
#define DATUM		"14.07.2018 12:00"
#define AUTOR		"* Christof Ermer *"

#include <avr\io.h>
#include <stdlib.h>
#include <avr/wdt.h>
#include "debug.h"
#include "RxRingBuf.h"

//WIEDER RAUS
#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "uart.h"
#include "Befehle.h"


typedef struct RingBUf
	{
	uint8_t u8Head=0;
	uint8_t u8Tail=0;
	uin16_t u16_BUFSizeMax;	
	};

// GLOBALS
//u16_BUFSizeMax never >256,  or change the Datatype from  HEAD & TAIL to "unsigned int". 
char u8aBuf[ u16_BUFSizeMax ]; // MUST BE n^2
 // *** PROTO TYPEN ***

// *********************************
void Flush_RxStr_Buf(void)
// *********************************
{
u8Head = 0;	//kopf
u8Tail = 0; 	// schwanz
//u8Head = u8Tail;
};

// *********************************
uint8_t RxStrBuf_WriteC(unsigned char ucRx)  //Rckgabeflag: Ok--> 0
// *********************************
{
uint16_t u16TempHead;
u16TempHead = (u8Head + 1) & RX_STR_BUFFER_MASK;
if( u16TempHead == u8Tail )
	{
	return RXSTRBUF_OVL; // ckgabeflag: RXSTRBUF_OVL --> !=0
	}
else
	{
/*
uart_puts_p( PSTR("\r*** INHERLAB RxStrBuf_WriteC:") );
uart_puts( itoa( ucRx, gcaNumStr,  10) );

uart_puts_p( PSTR("\r***TEMPHEAD:") );
uart_puts( itoa( u16TempHead, gcaNumStr,  10) );
*/
	u8Head = u16TempHead;
	u8aBuf[ u16TempHead ] = ucRx ;	

/*uart_puts_p( PSTR("\r***u8aBuf[ u16TempHead ]") );
uart_puts( itoa( u8aBuf[ u16TempHead ], gcaStr,  10) );
uart_putc( 13 );
*/
	};

Toggle_Bit( RxStrBytes_Available() );	
return RXStrBUF_OK; //return 0 = OK
};


// *********************************
int RxStrBuf_ReadC( void )
// *********************************
{
if ( u8Head == u8Tail )
	{
	return BUFFER_EMPTY;
	};
/* calculate /store buffer index */	
u8Tail = (u8Tail+1) & RX_STR_BUFFER_MASK; 
/* get data from receive buffer */

 return u8aBuf[ u8Tail ];    
};


// **************************
uint8_t RxStrBytes_Available(void) /* Bytes im RingBuf ? */
// **************************
{
return (RX_STR_BUFFER_MASK + u8Head - u8Tail ) % RX_STR_BUFFER_MASK;
}; 



// **************************
uint8_t Check_Overload_RingBuf(void) /* Overload State? RingBuf ? */
// **************************
{
if( ((u8Head  + 1) & RX_STR_BUFFER_MASK) == u8Tail )
	{
	return RXSTRBUF_OVL; // returnflag: RXSTRBUF_OVL --> !=0
	};
return RXStrBUF_OK;
}; 





